package com.ruoyi.ems.mapper;

import com.ruoyi.ems.domain.ElecPgSupplyH;
import com.ruoyi.ems.model.QueryMeter;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 电网供应计量-小时Mapper接口
 *
 * @author ruoyi
 * @date 2024-08-09
 */
public interface ElecPgSupplyHMapper {
    /**
     * 查询电网供应计量-小时
     *
     * @param id 电网供应计量-小时主键
     * @return 电网供应计量-小时
     */
    ElecPgSupplyH selectPgSupplyHById(Long id);

    /**
     * 查询电网供应计量-小时列表
     *
     * @param elecPgSupplyH 电网供应计量-小时
     * @return 电网供应计量-小时集合
     */
    List<ElecPgSupplyH> selectPgSupplyHList(ElecPgSupplyH elecPgSupplyH);

    List<ElecPgSupplyH> selectPgSupplyHAllArea(ElecPgSupplyH elecPgSupplyH);

    Map<String, Object> calThisDaySupply(@Param("thisDay") String thisDay);

    @MapKey("timeIndex")
    Map<String, Map<String, Object>> calThisDaySupplyByH(@Param("thisDay") String thisDay);

    /**
     * 查询电网供应计量-小时列表
     *
     * @param queryMeter 查询对象
     * @return 电网供应计量-小时集合
     */
    List<ElecPgSupplyH> selectPgSupplyH(QueryMeter queryMeter);

    /**
     * 新增电网供应计量-小时
     *
     * @param elecPgSupplyH 电网供应计量-小时
     * @return 结果
     */
    int insertPgSupplyH(ElecPgSupplyH elecPgSupplyH);

    /**
     * 批量新增电网供应计量-小时
     * @param list 电网供应计量-小时集合
     * @return 结果
     */
    int insertBatch(List<ElecPgSupplyH> list);

    /**
     * 修改电网供应计量-小时
     *
     * @param elecPgSupplyH 电网供应计量-小时
     * @return 结果
     */
    int updatePgSupplyH(ElecPgSupplyH elecPgSupplyH);

    ElecPgSupplyH calDaySupplyByH(QueryMeter param);

    List<ElecPgSupplyH> calMonthSupplyByH(ElecPgSupplyH param);

    /**
     * 删除电网供应计量-小时
     *
     * @param id 电网供应计量-小时主键
     * @return 结果
     */
    int deletePgSupplyHById(Long id);

    /**
     * 批量删除电网供应计量-小时
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deletePgSupplyHByIds(Long[] ids);
}
